Resource

Service Code Repository

Link code repositories to service items with the path where the service code lives.

The Service Code Repository Model

Properties

  • Name
    _id
    Type
    Object ID
    Description

    ID of this object

  • Name
    createdAt
    Type
    Date
    Description

    Date and Time when the object was created.

  • Name
    updatedAt
    Type
    Date
    Description

    Date and Time when the object was updated.

  • Name
    project
    Type
    Project
    Description

    Relation to Project Resource in which this object belongs

  • Name
    projectId
    Type
    Object IDRequired
    Description

    ID of your Project in which this object belongs

  • Name
    service
    Type
    Service
    Description

    Relation to Service Resource in which this object belongs

  • Name
    serviceId
    Type
    Object IDRequired
    Description

    ID of your Service in which this object belongs

  • Name
    codeRepository
    Type
    Code Repository
    Description

    Relation to Code Repository in which this object belongs

  • Name
    codeRepositoryId
    Type
    Object IDRequired
    Description

    ID of your Code Repository in which this object belongs

  • Name
    servicePathInRepository
    Type
    Long Text
    Description

    The path in the repository where the service code lives (e.g., /services/api or /src/backend)

  • Name
    createdByUser
    Type
    User
    Description

    Relation to User who created this object (if this object was created by a User)

  • Name
    createdByUserId
    Type
    Object ID
    Description

    User ID who created this object (if this object was created by a User)

  • Name
    enableAutomaticImprovements
    Type
    Boolean
    Description

    Enable to automatically create pull requests to improve the code for this service.

  • Name
    maxOpenPullRequests
    Type
    Number
    Description

    Maximum number of open pull requests that can create for this service at any given time.

  • Name
    restrictedImprovementActions
    Type
    JSON
    Description

    Restrict code improvements to only these actions. If empty, all improvement actions are allowed.

GETorPOST/api/service-code-repository/get-list

List

This endpoint allows you to retrieve a paginated list of all your Service Code Repository. By default, a maximum of ten Service Code Repository are shown per page.

Optional Query Params

  • limit
    number
    Number of objects to fetch. By default 10, you can increase this count up to 100
  • skip
    number
    Number of objects to skip. This can be useful in pagination

Optional Request Body

List Request

POST
/api/service-code-repository/get-list?skip=0&limit=10
Headers
Content-Type: application/json
ApiKey: YOUR_API_KEY
Body
{
  "select": {
    "codeRepositoryId": true,
    "projectId": true,
    "serviceId": true,
    "codeRepository": true,
    "createdByUser": true
  },
  "query": {
    "servicePathInRepository": "/services/api"
  },
  "sort": {
    "createdAt": -1
  }
}

Response

{
  "count": 10,
  "limit": 10,
  "skip": 0,
  "data": [
    {
      "_id": "377ab970-28fe-11f1-b591-3fdcef396aba",
      "codeRepositoryId": "b8c9d0e1-f2a3-4567-bc89-de01fa234567",
      "projectId": "5f8b9c0d-e1a2-4b3c-8d5e-6f7a8b9c0d1e",
      "serviceId": "f6a7b8c9-d0e1-2345-fa67-bc89de012345",
      "codeRepository": "b8c9d0e1-f2a3-4567-bc89-de01fa234567",
      "createdByUser": "c3d4e5f6-a7b8-9012-cd34-ef56ab789012"
    },
    {
      "_id": "377ab971-28fe-11f1-b591-3fdcef396aba",
      "codeRepositoryId": "b8c9d0e1-f2a3-4567-bc89-de01fa234567",
      "projectId": "5f8b9c0d-e1a2-4b3c-8d5e-6f7a8b9c0d1e",
      "serviceId": "f6a7b8c9-d0e1-2345-fa67-bc89de012345",
      "codeRepository": "b8c9d0e1-f2a3-4567-bc89-de01fa234567",
      "createdByUser": "c3d4e5f6-a7b8-9012-cd34-ef56ab789012"
    },
    {
      "_id": "377ab972-28fe-11f1-b591-3fdcef396aba",
      "codeRepositoryId": "b8c9d0e1-f2a3-4567-bc89-de01fa234567",
      "projectId": "5f8b9c0d-e1a2-4b3c-8d5e-6f7a8b9c0d1e",
      "serviceId": "f6a7b8c9-d0e1-2345-fa67-bc89de012345",
      "codeRepository": "b8c9d0e1-f2a3-4567-bc89-de01fa234567",
      "createdByUser": "c3d4e5f6-a7b8-9012-cd34-ef56ab789012"
    }
  ]
}
GETorPOST/api/service-code-repository/:id/get-item

Get item by ID

This endpoint allows you to retrieve Service Code Repository by ID.

  • id
    text
    ID of the Object

Optional Request Body

Get Item Request

POST
/api/service-code-repository/:id/get-item
Headers
Content-Type: application/json
ApiKey: YOUR_API_KEY
Body
{
  "select": {
    "codeRepositoryId": true,
    "projectId": true,
    "serviceId": true,
    "codeRepository": true,
    "createdByUser": true
  }
}

Response

{
  "_id": "377ab970-28fe-11f1-b591-3fdcef396aba",
  "codeRepositoryId": "b8c9d0e1-f2a3-4567-bc89-de01fa234567",
  "projectId": "5f8b9c0d-e1a2-4b3c-8d5e-6f7a8b9c0d1e",
  "serviceId": "f6a7b8c9-d0e1-2345-fa67-bc89de012345",
  "codeRepository": "b8c9d0e1-f2a3-4567-bc89-de01fa234567",
  "createdByUser": "c3d4e5f6-a7b8-9012-cd34-ef56ab789012"
}
POST/api/service-code-repository/count

Count

This endpoint allows you to retrieve the count of all your Service Code Repository.

Optional Request Body

Count Request

POST
/api/service-code-repository/count
Headers
Content-Type: application/json
ApiKey: YOUR_API_KEY
Body
{
  "query": {
    "servicePathInRepository": "/services/api"
  }
}

Response

{
  "count": 107
}
POST/api/service-code-repository

Create Service Code Repository

This endpoint allows you to create a new object.

Create Request

POST
/api/service-code-repository
Headers
Content-Type: application/json
ApiKey: YOUR_API_KEY
Body
{
  "data": {
    "codeRepositoryId": "b8c9d0e1-f2a3-4567-bc89-de01fa234567",
    "projectId": "5f8b9c0d-e1a2-4b3c-8d5e-6f7a8b9c0d1e",
    "serviceId": "f6a7b8c9-d0e1-2345-fa67-bc89de012345",
    "codeRepository": "b8c9d0e1-f2a3-4567-bc89-de01fa234567",
    "createdByUser": "c3d4e5f6-a7b8-9012-cd34-ef56ab789012"
  }
}

Response

{
  "_id": "377ab970-28fe-11f1-b591-3fdcef396aba",
  "codeRepositoryId": "b8c9d0e1-f2a3-4567-bc89-de01fa234567",
  "projectId": "5f8b9c0d-e1a2-4b3c-8d5e-6f7a8b9c0d1e",
  "serviceId": "f6a7b8c9-d0e1-2345-fa67-bc89de012345",
  "codeRepository": "b8c9d0e1-f2a3-4567-bc89-de01fa234567",
  "createdByUser": "c3d4e5f6-a7b8-9012-cd34-ef56ab789012"
}
PUT/api/service-code-repository/:id

Update by ID

This endpoint allows you to update object by its ID.

Alternative Methods

For clients that do not support PUT requests, you can use POST or GET with the same request headers and body:

POST/api/service-code-repository/:id/update-item
GET/api/service-code-repository/:id/update-item

Update Request

PUT
/api/service-code-repository/:id
Headers
Content-Type: application/json
ApiKey: YOUR_API_KEY
Body
{
  "data": {
    "servicePathInRepository": "/services/api",
    "enableAutomaticImprovements": true,
    "maxOpenPullRequests": 100
  }
}

Response

{}
DELETE/api/service-code-repository/:id

Delete by ID

This endpoint allows you to delete object by its ID.

Alternative Methods

For clients that do not support DELETE requests, you can use POST or GET with the same request headers and body:

POST/api/service-code-repository/:id/delete-item
GET/api/service-code-repository/:id/delete-item

Delete Request

DELETE
/api/service-code-repository/:id
Headers
Content-Type: application/json
ApiKey: YOUR_API_KEY

Response

{}

Permissions

Your API Token needs permissions to create, update, read or delete this resource. If you do not have permissions to make a request a 4xx status will be sent as response.

Read Permissions

Required to read Service Code Repository

  • Project Owner
  • Project Admin
  • Project Member
  • Read Service Code Repository
  • Read All Project Resources

Create Permissions

Required to create Service Code Repository

  • Project Owner
  • Project Admin
  • Project Member
  • Create Service Code Repository

Update Permissions

Required to update Service Code Repository

  • Project Owner
  • Project Admin
  • Project Member
  • Edit Service Code Repository

Delete Permissions

Required to delete Service Code Repository

  • Project Owner
  • Project Admin
  • Project Member
  • Delete Service Code Repository